// VectSort.cpp: implementation of the CVectSort class.
//
//////////////////////////////////////////////////////////////////////

#include "VectSort.h"
#include "memory.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVectSort::CVectSort()
{

}

CVectSort::~CVectSort()
{

}

int CVectSort::SortAscending(const int *unsortedVect, int *sortedVect, int size)
{
	return BubbleSort(unsortedVect, sortedVect, size, true);
}

int CVectSort::SortDescending(const int *unsortedVect, int *sortedVect, int size)
{
	return BubbleSort(unsortedVect, sortedVect, size, false);
}

double CVectSort::SortAscending(const double *unsortedVect, double *sortedVect, int size)
{
	return BubbleSort(unsortedVect, sortedVect, size, true);
}

double CVectSort::SortDescending(const double *unsortedVect, double *sortedVect, int size)
{
	return BubbleSort(unsortedVect, sortedVect, size, false);
}

int CVectSort::BubbleSort(const int *src, int *dst, int size, bool ascending)
{
	memcpy(dst, src, size*sizeof(int));
	
	for (int i=0; i<size; i++)
	{
		for (int j=0; j<(size-1); j++)
		{
			if (ascending)
			{
				if (dst[j] > dst[j+1])
				{
					int swap;
					swap = dst[j];
					dst[j] = dst[j+1];
					dst[j+1] = swap;
				}
			}
			else
			{
				if (dst[j] < dst[j+1])
				{
					int swap;
					swap = dst[j];
					dst[j] = dst[j+1];
					dst[j+1] = swap;
				}
			}
		}
	}
	
	int median = dst[int(size/2)];
	return median;
}

double CVectSort::BubbleSort(const double *src, double *dst, int size, bool ascending)
{
	memcpy(dst, src, size*sizeof(double));
	
	for (int i=0; i<size; i++)
	{
		for (int j=0; j<(size-1); j++)
		{
			if (ascending)
			{
				if (dst[j] > dst[j+1])
				{
					double swap;
					swap = dst[j];
					dst[j] = dst[j+1];
					dst[j+1] = swap;
				}
			}
			else
			{
				if (dst[j] < dst[j+1])
				{
					double swap;
					swap = dst[j];
					dst[j] = dst[j+1];
					dst[j+1] = swap;
				}
			}
		}
	}
	
	double median = dst[int(size/2)];
	return median;
}